﻿#pragma strict

//Drago's Camera Angle Script v1.1
//This script requires the MainCameraScript attached to the Main camera
//v1.0 - initial build
//v1.1 - Updates to script flow, ease of use and bug squashing

//Get required component
@script RequireComponent(BoxCollider)

//Setup variables
var xAngle : float;
var yAngle : float;
var zAngle : float;
var speed : float;
var smoothTransition : boolean;
//Hide the rest that dont need to changed.
private var initialAngleX : float;
private var initialAngleY : float;
private var initialAngleZ : float;
private var desiredAngleX : float;
private var desiredAngleY : float;
private var desiredAngleZ : float;
private var time : float = 0;
private var onEnter : boolean;

function Start () {
//Create Script Reference
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
//Get initial Angle
initialAngleX = script.xAngle;
initialAngleY = script.yAngle;
initialAngleZ = script.zAngle;
//Create Desired Angle
desiredAngleX = script.xAngle + -xAngle;
desiredAngleY = script.yAngle + -yAngle;
desiredAngleZ = script.zAngle + -zAngle;


}

function Update () {


}

function SmoothTransition (){
//Setup variable for 0 - 1 value
//check if entering or exiting
if (onEnter){
// increase by time in 60th of seconds. divided by zoom time in seconds.
time = time + (0.01667 / speed);
}else{
// decreasing back to initialDistance.
time = time - (0.01667 / speed);
}
//create the current time variable
var currentTime : float = time;
//Create variable to store current distance, with lerp between desired and initial.
var currentAngleX : float =  Mathf.Lerp(initialAngleX, desiredAngleX, currentTime);
var currentAngleY : float =  Mathf.Lerp(initialAngleY, desiredAngleY, currentTime);
var currentAngleZ : float =  Mathf.Lerp(initialAngleZ, desiredAngleZ, currentTime);
//Create script reference
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
	//Set the Angle to current Angles	
	script.xAngle = currentAngleX;
	script.yAngle = currentAngleY;
	script.zAngle = currentAngleZ;
	
// If the time variable ever exeeds 1 or goes below 0 stop the repeating. (saves power)
	if (time >= 1){
		CancelInvoke("SmoothTransition");
		
	}
	if (time <= 0){
		CancelInvoke("SmoothTransition");
		
	}
}


function OnTriggerEnter () {
	//set entering to true
	onEnter = true;
	//cancel any existing repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Create script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
		
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating the method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{

//Change the distance varaible in main script.
		script.xAngle = desiredAngleX;
		script.yAngle = desiredAngleY;
		script.zAngle = desiredAngleZ;
		
		}
	}
	
function OnTriggerExit () {
	//set entering to false
	onEnter = false;
	//cancel any existing repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Create script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
		
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating the method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{

//Change the distance varaible in main script.
		script.xAngle = initialAngleX;
		script.yAngle = initialAngleY;
		script.zAngle = initialAngleZ;
		
		}
	}