﻿#pragma strict

//Drago's Camera Offset Script v1.1
//This script requires the MainCameraScript attached to the Main camera
//v1.0 - initial build
//v1.1 - bug fixes and updates to flow of script

//Get required component
@script RequireComponent(BoxCollider)

//Setup variables Most of these are self explainatoy 
var xOffset : float;
var yOffset : float;
var zOffset : float;
var speed : float;
//this is usually always true
var smoothTransition : boolean;
// make the rest private that dont need to changed by us :P
private var initialOffsetX : float;
private var initialOffsetY : float;
private var initialOffsetZ : float;
private var desiredOffsetX : float;
private var desiredOffsetY : float;
private var desiredOffsetZ : float;
private var time : float = 0;
private var onEnter : boolean;

function Start () {
//Create Script Reference
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
//Get initial offset
initialOffsetX = script.xOffset;
initialOffsetY = script.yOffset;
initialOffsetZ = script.zOffset;
//Create Desired offset
desiredOffsetX = script.xOffset + -xOffset;
desiredOffsetY = script.yOffset + -yOffset;
desiredOffsetZ = script.zOffset + -zOffset;


}
//Hai updtate function, I don't need you :P
function Update () {


}

function SmoothTransition (){
//Setup variable for 0 - 1 value
//check if entering or exiting
if (onEnter){
// increase by time in 60th of seconds. divided by zoom time in seconds.
time = time + (0.01667 / speed);
}else{
// decreasing back to initialOffset.
time = time - (0.01667 / speed);
}
//create the current time variable
var currentTime : float = time;
//Create variable to store current Offset, with lerp between desired and initial.
var currentOffsetX : float =  Mathf.Lerp(initialOffsetX, desiredOffsetX, currentTime);
var currentOffsetY : float =  Mathf.Lerp(initialOffsetY, desiredOffsetY, currentTime);
var currentOffsetZ : float =  Mathf.Lerp(initialOffsetZ, desiredOffsetZ, currentTime);
//Create script reference
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
	//Set the offset to current Offsets	
	script.xOffset = currentOffsetX;
	script.yOffset = currentOffsetY;
	script.zOffset = currentOffsetZ;
	
// If the time variable ever exeeds 1 or goes below 0 stop the repeating. (saves power)
	if (time >= 1){
		CancelInvoke("SmoothTransition");
		
	}
	if (time <= 0){
		CancelInvoke("SmoothTransition");
		
	}
}


function OnTriggerEnter () {
	//set entering to true
	onEnter = true;
	//cancel any existing repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Create script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
		
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating the method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{

//Change the distance varaible in main script.
		script.xOffset = desiredOffsetX;
		script.yOffset = desiredOffsetY;
		script.zOffset = desiredOffsetZ;
		
		}
	}
	
function OnTriggerExit () {
	//set entering to false
	onEnter = false;
	//cancel any existing repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Create script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
		
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating the method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{

//Change the distance varaible in main script.
		script.xOffset = initialOffsetX;
		script.yOffset = initialOffsetY;
		script.zOffset = initialOffsetZ;
		
		}
	}