﻿#pragma strict

//Drago's Camera Zoom trigger script v1.2
//This script requires the MainCameraScript attached to the Main camera
//v1.0 - initial build
//v1.1 - Smooth tranision added
//v1.2 - Multi way transition (enter and exit) and bug fixes
//planned v1.3 final camera zoom updater

//Get required component
@script RequireComponent(BoxCollider)

//Variables
var zoom : float;
var smoothTransition : boolean;
var zoomTime : float;
//some private variables variables
private var initialDistance : float;
private var desiredDistance : float;
private var time : float = 0;
private var onEnter : boolean;

function Start () {

//Make sure collider is trigger
collider.isTrigger = true;

//Make script reference Make sure the camera's name is Main Camera
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
//Set the variables for begining and end distances
initialDistance = script.distance;
//desired distance is the original distance - zoom
desiredDistance = (script.distance) + -zoom; 

}

function Update () {


}	
//To create a smooth transition between points
function SmoothTransition (){
//Setup variable for 0 - 1 value
//check if entering or exiting
if (onEnter){
// increase by time in 60th of seconds. divided by zoom time in seconds.
time = time + (0.01667 / zoomTime);
}else{
// decreasing back to initialDistance.
time = time - (0.01667 / zoomTime);
}
//create the current time variable
var currentTime : float = time;
//Create variable to store current distance, with lerp between desired and initial.
var currentDistance : float =  Mathf.Lerp(initialDistance, desiredDistance, currentTime);
//Create script reference
var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
	//Set the distance to current distance	
	script.distance = currentDistance;
	
// If the time variable ever exeeds 1 or goes below 0 stop the repeating. (saves power)
	if (time >= 1){
		//cancel the invoke
		CancelInvoke("SmoothTransition");
// Unsure if this will work so i commented it out.		
//		if (setDistanceAsFinal){
//			time = 0;
//			//Set the variables for begining and end distances
//			initialDistance = script.distance;
//
//			desiredDistance = (script.distance) + -zoom; 
//		}
		
	}
	if (time <= 0){
		CancelInvoke("SmoothTransition");
// Again for safty purpose's commented this out		
//		if (setDistanceAsFinal){
//			time = 0;
//			
//			//Set the variables for begining and end distances
//			initialDistance = script.distance;
//
//			desiredDistance = (script.distance) + -zoom;
//		}
		
	}
}

// When an object enters the trigger. Need's to be updated to check for player will do next update
function OnTriggerEnter () {
	//set entering to true
	onEnter = true;
	//cancel any existing repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Create script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
		
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating the method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{
//Create new variable to hold the end zoom result. can be optimized
		var newDistance : float = script.distance + -zoom;
//Change the distance varaible in main script.
		script.distance = newDistance;
		}
	}

function OnTriggerExit () {
	//Cancel any repetition (stops overlap)
	CancelInvoke("SmoothTransition");
	//Exiting so Entering is false
	onEnter = false;
	//Create Script reference
	var script : MainCameraScript = GameObject.Find("Main Camera").GetComponent(MainCameraScript);
	//IF the transition is smooth or not
	if (smoothTransition){
	//start repeating of method at 60fps
 	InvokeRepeating("SmoothTransition" , 0, 0.01667);
		}else{
//create new variable to hold the end zoom result. can be optimized
		var newDistance : float = initialDistance;
//Change the distance varaible in main script.
		script.distance = newDistance;
		}
	


}
